#ifndef BOARD_HPP
#define BOARD_HPP
#include "communication.hpp"
#include "image.hpp"
#include "ground_truth.hpp"

typedef struct {
    CvPoint lower;
    CvPoint upper;
    char color;
    short index;
    double avg_intensity;
} corn_draw;

void all_cylinders(RgbImage& left_input, RgbImage& right_input, uint64_t timestamp);
void alter_focal_length(double value);
void draw_cylinder_config(RgbImage& input);
void alter_view_height(double value);
void alter_angle(double value);
void cylinder_draw(RgbImage& left_input,RgbImage& right_input, int abs_y, int abs_x);
void hard_coded_cylinders(RgbImage& input,BwImage& regions);
void enemy_mapping(RgbImage& left, RgbImage& right,uint64_t timestamp);
void update_elements(uint64_t timestamp, std::vector< CvPoint2D32f > &tomatoes, std::vector< CvPoint2D32f > &oranges, std::vector< CvPoint2D32f > &corns);
//void update_elements(uint64_t timestamp, std::vector< CvPoint2D32f > &objects);
bool in_view_area(robot_position &pos,int y, int x);
void init_game_elements();

void hard_code_add(corn_draw& input, int y1, int x1, int y2, int x2, short index);
void corn_populate(std::vector< CvPoint > &corn);
void tomato_populate(std::vector< CvPoint > &tomato);

// this is to remove borders
std::pair<CvPoint, CvPoint> find_border_point(robot_position &left,robot_position &right, int abs_y, int abs_x);
void point_draw(BwImage& left, BwImage& right,std::pair<CvPoint, CvPoint> &a, std::pair<CvPoint, CvPoint> &b);
void point_draw(RgbImage& left, RgbImage& right,std::pair<CvPoint, CvPoint> &a, std::pair<CvPoint, CvPoint> &b);
//void border_draw(RgbImage& left_input, RgbImage& right_input,uint64_t timestamp );
void border_draw(frame<RgbPixel>& left, frame<RgbPixel>& right,uint64_t timestamp );
bool lineSegmentIntersection(CvPoint &a, CvPoint &b, CvPoint &c, CvPoint &d,double &x, double &y);
bool border_is_in_view(CvPoint &p);
#endif // BOARD_HPP
