#ifndef CANNY_HPP_INCLUDED
#define CANNY_HPP_INCLUDED
#include "image.hpp"
#include <vector>

class Canny {
	private:
		int height,width,lower_threshold,upper_threshold;
		std::vector< std::vector<double> > gradient, grad_direction, processed_image;
		void calculate_gradient(BwImage& input,CvMat* dx,CvMat* dy);
		void suppress_nonmaxima();
		void detect_edge();
		void follow_edge(int r, int c);
	public:
		Canny(int x_size, int y_size);
		void set_threshold(int lower, int upper);
		void perform(IplImage* input,CvMat* dx,CvMat* dy);
};
#endif // CANNY_HPP_INCLUDED
