#ifndef CONVERSION_HPP
#define CONVERSION_HPP
#include "image.hpp"
#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif
#ifndef MAX
#define MAX(a,b) (((a)<(b))?(b):(a))
#endif
#define CLIP(a,l,u) ((a)<(l)?(l):(((a)>(u)) ? (u) : (a) ) )
#include "dc1394/dc1394.h"

int HuefromRGB(RgbPixel &p);
double SatfromRGB(RgbPixel &p);
void RGB_threshold_on_HSV(IplImage *raw_input, IplImage *raw_output, CvSize& imageSize);
void YUV444toRGB888(RgbPixel& output, const unsigned char &y, const unsigned char &u, const unsigned char &v);
void YUYVtoBW(unsigned char *input, IplImage* raw_output, CvSize& imageSize);
void YUYVtoBW_matched(unsigned char *input, IplImage* raw_output, CvSize& imageSize);
void YUYVtoRGB(unsigned char *input, IplImage* raw_output,CvSize& imageSize);
void YUYVtoYUV(unsigned char *input, IplImage* raw_output,CvSize& imageSize);
void color_convert(unsigned char *input, IplImage* raw_output, BwImage& intensity, CvSize& imageSize);
void setRGB(RgbPixel& output, unsigned char &r, unsigned char &g, unsigned char &b);
void split_3channels(RgbImage& input, BwImage& ch1, BwImage& ch2, BwImage& ch3);
void setRGBfromYUV(YuvImage &yuv, RgbImage &rgb, int y, int x);
void Y800toBW(unsigned char *input, BwImage& output);
void UYVYtoRGB(unsigned char *input, RgbImage& output);
void Y800toRGB(unsigned char *input, RgbImage& output);
typedef struct {
        int x;
        int y;
} vec;
void YUVtoBW(IplImage* raw_input, IplImage* raw_output, CvSize& imageSize);
extern std::vector<unsigned char> intensity_exclusion;
extern IplImage *exclusion;
extern opt_struct options;
bool point_in_triangle(vec p,vec a, vec b,vec c);
vec point(int x, int y);
#endif
