#ifndef CORRESPONDENCE_HPP
#define CORRESPONDENCE_HPP
#include "image.hpp"
#include "main.hpp"
#include "segmentation.hpp"
#include <vector>
void calculate_histogram(IplImage* raw_input, IplImage* raw_output);
void block_draw(RgbImage& output, int y0, int x0, int y_size, int x_size, int distance);
void hough_matching_correspondence(CvSeq* left_circles, CvSeq* right_circles, IplImage* raw_output, IplImage* location);
void edge_matching_correspondence();
void edge_data(IplImage* raw_input, IplImage* raw_output);
void edge_block_matching(IplImage* raw_output);
void edge_data_test(frame<RgbPixel>& camera, IplImage* raw_output);
void edge_data_verbose(frame<RgbPixel>& camera, IplImage* raw_output);
void edge_matching_correspondence(IplImage *raw_left, IplImage* raw_output);
void block_matching_correspondence(IplImage* raw_left, IplImage* raw_right, IplImage* raw_output);
void thresholding_test(IplImage* raw_input, IplImage* histogram);
void anaglyphic_stereo(IplImage* raw_output);
void RGB_Gradient(IplImage* raw_input, CvMat* raw_output, int direction);
void RGB_gradient_ignore_black(RgbImage& input, CvMat* raw_output);
void BW_Gradient(IplImage* raw_input, IplImage* raw_output, int direction);
void gradient_merge(CvMat* raw_dx, CvMat* raw_dy, CvMat* raw_output);
void RLE_match(std::vector< std::vector< run_len > > &left_rle, std::vector< std::vector< run_len > > &right_rle, RgbImage& output, int size_threshold, int color_threshold);
unsigned short color_difference(RgbPixel& a, RgbPixel& b);
#endif // CORRESPONDENCE_HPP
