#ifndef INDIVIDUAL_PROCESSING_HPP
#define INDIVIDUAL_PROCESSING_HPP
#include "image.hpp"
#include "main.hpp"
#include "canny.hpp"
#include "wrapper.hpp"
void new_frame( int camera_id, unsigned char *input_buffer);
void compute_on_frame(frame<RgbPixel> &camera, double incoming_time, double conversion_time);

#define LEFT_CAMERA 0
#define RIGHT_CAMERA 1
//CvMemStorage* left_storage, *right_storage;

// global mutexes, barriers etc.
extern pthread_mutex_t display;
extern pthread_barrier_t barrier_before_processing;
extern pthread_barrier_t barrier_after_processing;
extern pthread_barrier_t barrier_correspondence;

extern volatile  int cameras_ready;
void init_matrices(frame<RgbPixel> &camera, int channels);
void release_matrices(frame<RgbPixel> &camera);
extern frame<RgbPixel> cam_left;
extern frame<RgbPixel> cam_right;
#endif // INDIVIDUAL_PROCESSING_HPP
