//#include <complex.h>
#include <fftw3.h>
#include "conversion.hpp"
#include "image.hpp"
#include <iostream>
using namespace std;
#define N (640*480)

double fourierSpectrum(double re, double im)
{
    return sqrt(pow(re, 2) + pow(im, 2));
}

int main()
{
	fftw_plan forward, backward, forward_compare;
	fftw_complex *temp, *temp_compare,*in,*out,*in_compare, *filter, *inverse_filter, *temp_out;
CvSize imageSize=cvSize(640,480);
	CvCapture* cam_left = cvCaptureFromCAM( 0 );
	IplImage* raw_input = cvCreateImage(imageSize, 8, 1);
	IplImage* raw_temp = cvCreateImage(imageSize, 8, 1);
	IplImage* raw_output = cvCreateImage(imageSize, 8, 1);
	IplImage* raw_spectrum = cvCreateImage(imageSize, 8, 3);
	RgbImage spectrum(raw_spectrum);
	BwImage output(raw_output);
         in = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
         in_compare = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
         temp = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
         temp_compare = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
         temp_out = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
        filter = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) *N);
        inverse_filter = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) *N);
	 out = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
         forward = fftw_plan_dft_2d(480, 640, in, temp,FFTW_FORWARD, FFTW_MEASURE);
         forward_compare = fftw_plan_dft_2d(480, 640, in_compare, temp_compare,FFTW_FORWARD, FFTW_MEASURE);
	 backward = fftw_plan_dft_2d(480, 640, temp_out, out , FFTW_BACKWARD, FFTW_MEASURE);

    // creating motion deblur-filter.
    double V=0.002;
	double T=0.5;
	double L=5;
	double gamma=15.0;
    for(int u=0; u<imageSize.width; u++) {
        double over = sin(L*(u-imageSize.width/2)*M_PI/imageSize.width);
        double under = L*sin((u-imageSize.width/2)*M_PI/imageSize.width);
        //double under = M_PI*V*(u-imageSize.height/2);
        //double over = sin(M_PI*V*T*(u-imageSize.height/2));
        double h=1.0;
        if(under != 0.0) {
            h=over/under;
        } else {
                    printf("%f %f\n",over,under);
        }

        for(int v=0; v<imageSize.height; v++) {
             filter[v*imageSize.width+u][0]=h;
               filter[v*imageSize.width+u][1]=h;
        }
        double val=gamma;
        if(abs(1.0/h)<gamma) {
            val=1.0/h;
        }
        for(int v=0; v<imageSize.height; v++) {
               inverse_filter[v*imageSize.width+u][0]=val;
               inverse_filter[v*imageSize.width+u][1]=val;
        }
    }


cvNamedWindow("fourier");
cvNamedWindow("optimal");
cvNamedWindow("original");
	double spec=0.0;
	/*
	 while(1) {
		cvGrabFrame(cam_left);
		cvConvertImage(cvQueryFrame(cam_left),raw_input,CV_BGR2GRAY);
		BwImage input(raw_input);
		BwImage input_temp(raw_temp);
		for(int y=0; y<imageSize.height; y++)
			for(int x=0; x<imageSize.width; x++)
			{
				in[y*imageSize.width+x][0]= pow(-1.0,x+y)*input[y][x];
				//in[y*imageSize.width+x][0] = input[y][x].g;
				in[y*imageSize.width+x][1] = 0.0;
			}
         	fftw_execute(forward);
		// perform filtering here.
		    for(int i=0; i<N; i++)
		    {
                temp_out[i][0] = (temp[i][0]*inverse_filter[i][0])-(temp[i][1]*inverse_filter[i][1]);
                temp_out[i][1] = (temp[i][0]*inverse_filter[i][1])+(temp[i][1]*inverse_filter[i][0]);
			//temp_out[i][0] = temp[i][0];
			//temp_out[i][1] = temp[i][1];
            }

        cvSet(raw_spectrum,cvScalar(0,0,0));
		for(int y=0; y<imageSize.height; y++)
			for(int x=0; x<imageSize.width; x++)
			{
				spec = (255.0/13.0)* log(1+fourierSpectrum(temp_out[y*imageSize.width+x][0], temp_out[y*imageSize.width+x][1]));
				if(spec>=2*85) {
					spectrum[y][x].r = CLIP(spec,0,255);
				} else if(spec<2*85) {
					spectrum[y][x].b = CLIP(spec+86,0,255);
				} else if(spec<85) {
					spectrum[y][x].r = CLIP(spec+171,0,255);
				}
			}
		fftw_execute(backward);
		for(int y=0; y<imageSize.height; y++)
			for(int x=0; x<imageSize.width; x++)
			{
				output[y][x]=CLIP(pow(-1.0,x+y)*out[y*imageSize.width+x][0]/N,0,255);
			}
		cout << "loop" << endl;
		cvShowImage("fourier",raw_spectrum);
		cvShowImage("original",raw_input);
		cvShowImage("output", raw_output);
		cvSaveImage("output.png",raw_input);
		cvWaitKey(20);
	}
	*/
	cvConvertImage(cvLoadImage("image_output.png"),raw_input,CV_BGR2GRAY);
	cvConvertImage(cvLoadImage("image_before_threshold.png"),raw_temp,CV_BGR2GRAY);
	//cvCanny(raw_temp,raw_input,60,120,3);
			BwImage input(raw_input);
			BwImage input_compare(raw_temp);
		for(int y=0; y<imageSize.height; y++)
			for(int x=0; x<imageSize.width; x++)
			{
				in[y*imageSize.width+x][0]= pow(-1.0,x+y)*input[y][x];
				in_compare[y*imageSize.width+x][0]= pow(-1.0,x+y)*input_compare[y][x];
				//in[y*imageSize.width+x][0] = input[y][x].g;
				in[y*imageSize.width+x][1] = 0.0;
				in_compare[y*imageSize.width+x][1] = 0.0;
			}
         	fftw_execute(forward);
         	fftw_execute(forward_compare);
		// perform filtering here.
            /*
            for(int i=0; i<N; i++) {
               temp_out[i][0]=(temp[i][0]*temp_compare[i][0])-(temp[i][1]*temp_compare[i][1]);
               temp_out[i][1]=(temp[i][0]*temp_compare[i][1])-(temp[i][1]*temp_compare[i][0]);
            }
            */
            for(int i=0; i<N; i++)
		    {
		        //;
                temp_out[i][0] = (temp[i][0]*inverse_filter[i][0])-(temp[i][1]*inverse_filter[i][1]);
                temp_out[i][1] = (temp[i][0]*inverse_filter[i][1])+(temp[i][1]*inverse_filter[i][0]);
			//temp_out[i][0] = temp[i][0];
			//temp_out[i][1] = temp[i][1];
            }

        cvSet(raw_spectrum,cvScalar(0,0,0));
		for(int y=0; y<imageSize.height; y++)
			for(int x=0; x<imageSize.width; x++)
			{
				spec = (255.0/13.0)* log(1+fourierSpectrum(temp_out[y*imageSize.width+x][0], temp_out[y*imageSize.width+x][1]));
				if(spec>=2*85) {
					spectrum[y][x].r = CLIP(spec,0,255);
				} else if(spec<2*85) {
					spectrum[y][x].b = CLIP(spec+86,0,255);
				} else if(spec<85) {
					spectrum[y][x].r = CLIP(spec+171,0,255);
				}
			}
		fftw_execute(backward);
		for(int y=0; y<imageSize.height; y++)
			for(int x=0; x<imageSize.width; x++)
			{
				output[y][x]=CLIP(pow(-1.0,x+y)*out[y*imageSize.width+x][0]/N,0,255);
			}
		cout << "loop" << endl;
		cvShowImage("fourier",raw_spectrum);
		cvShowImage("original",raw_input);
		cvShowImage("optimal",raw_temp);
		cvShowImage("output", raw_output);
		//cvSaveImage("image_output.png",raw_output);
		cvWaitKey(0);
         fftw_destroy_plan(forward);
	 fftw_destroy_plan(backward);
         fftw_free(in); fftw_free(out); fftw_free(temp); fftw_free(temp_out); fftw_free(filter);
}
