#ifndef MAIN_HPP
#define MAIN_HPP
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string>
#include <fstream>
#include <sys/time.h>
#include <time.h>
#include <iostream>
#include "image.hpp"
#include "camera.hpp"
#include "individual_processing.hpp"
#include "conversion.hpp"
#include "correspondence.hpp"
#include "segmentation.hpp"
#include "hough.hpp"
#include <math.h>
#include <omp.h>
// native Linux methods.
#include <sys/resource.h>
#include <sys/types.h>

#define NUM_THREADS 2

#define FOURCC(a,b,c,d) (unsigned int)((((unsigned int)d)<<24)+(((unsigned int)c)<<16)+(((unsigned int)b)<<8)+a)
#define YUYV 0x56595559

void matrix_from_file(std::string filename, CvSize imageSize, CvMat* output);
void pixel_color(RgbPixel& pixel, int &element, int &rangesize, std::vector<int> &ranges, int &peak, int &bottom);
void value_to_color(CvMat* disp, IplImage* raw_output,int minval, int maxval);
double get_time();
double disparity_to_distance(int disparity);
double distance_to_view_x(double distance);
double distance_to_view_y(double distance);
void saveImage(IplImage *img_left, IplImage *img_right);
void on_mouse( int event, int x, int y, int flags, void* param );
int main (int argc, char **argv);

// global variables for various purposes.
extern struct timeval tp;
extern double zero;
extern int stop;
extern double time_left, time_right;
extern CvSize imageSize;
extern std::vector<int> global_ranges;
extern int global_rangesize;
#endif // MAIN_HPP
