#ifndef INCLUDE_SEGMENTATION_HPP
#define INCLUDE_SEGMENTATION_HPP
#include "image.hpp"
#include "communication.hpp"
#include <vector>
/*
typedef struct{
	int x,y;
} coord;
*/
typedef struct
{
    unsigned short pos, sz;
    RgbPixel colorval;
} run_len;

short calc_I1(RgbPixel& pixel);
short calc_I2(RgbPixel& pixel);
short calc_I3(RgbPixel& pixel);
void color_segmentation(IplImage* raw_inputIpl, IplImage* raw_output, double tolerance, int maxit);
double calculate_mean(IplImage* raw_input, int y, int x, int masksize);
double calculate_variance(IplImage *raw_input, int y, int x, int masksize);
RgbPixel calculate_mean_pixel(IplImage* raw_input, int y, int x, int masksize);
double intensity(RgbPixel &pixel);
void normalize(RgbPixel &pixel, double threshold);
void normalize_fix(RgbPixel &pixel, double threshold);
void detect_colors(RgbImage& input, RgbImage& output);
void run_length_encode(RgbImage& input, std::vector< std::vector < run_len >  > &rle);
void run_length_encode_diff(RgbImage& input, std::vector< std::vector < run_len >  > &rle);
void fill_holes(RgbImage& input, RgbImage& vertical_temp, int max_variance);
void color_encode(RgbImage& input, CvMat* raw_variance, RgbImage& output, int var1, int var2);
int skeletonize(BwImage& input);
bool pixel_is_zero(RgbPixel& pixel);
bool RGB_color_sphere(RgbPixel& input, RgbPixel& compare, int radius);
double RGB_color_diff(RgbPixel& input, RgbPixel& compare);
void setval(RgbPixel& p, unsigned char r, unsigned char g, unsigned char b);
void region_fix(RgbImage& input, RgbImage& original, RgbImage& temp, int region_variance);
void smooth_region(RgbImage& input);
void border_detect(RgbImage& input, RgbImage& output);
#endif // INCLUDE_SEGMENTATION_HPP
