#include "state.hpp"
#include <pthread.h>
/*
    This methods in this file is used to ensure that access to
    various variables is only done in a threadsafe fashion.

    This could've been achieved better with classes,
    as the variables are still global, and accessible for all threads in a non-threadsafe manner.
*/
pthread_mutex_t state_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t pickup_mutex = PTHREAD_MUTEX_INITIALIZER;
int global_state=-1;
int object_pickup_counter=0;

int getGlobalState() {
    pthread_mutex_lock(&state_mutex);
    int temp = global_state;
    pthread_mutex_unlock(&state_mutex);
    return temp;
}

void setGlobalState(int value) {
    pthread_mutex_lock(&state_mutex);
    global_state=value;
    pthread_mutex_unlock(&state_mutex);
}

void increasePickupCount() {
    pthread_mutex_lock(&pickup_mutex);
    object_pickup_counter++;
    pthread_mutex_unlock(&pickup_mutex);
}

int getPickupCount() {
    pthread_mutex_lock(&pickup_mutex);
    int temp = object_pickup_counter;
    pthread_mutex_unlock(&pickup_mutex);
    return temp;
}

/*
void getCylinderConfig() {
    pthread_mutex_lock(&cylinder_config_mutex);
*/
